/*

Commande de deux servomoteurs à l'aide d'une télécommande IR
-------------------------------------------------------------
destinés à l'orientation Pan/Tilt d'une camera.
ATTENTION: La vitesse de déplacement est limitée par la durée des trames IR.  10 s environ pour 90° 
Pan =  Panoramique.
Tilt = Inclinaison.
Inversez les fils de commande des servo moteurs si nécessaire (Pin 9 et 10).
Utiliser de préference une télécommande munie de flèches de direction.
Les codes sont à modifier selon la télécommande  et les boutons choisis.
Pour cela, après avoir branché la diode IR sur le module Arduino comme spécifié 
(sortie données Pin D11 ) utiliser le programme "CodeTele" joint au fichier.

Dans la fonction "Case" de void Loop
Si , à chaque appui, la télécommande génère un code unique puis une série de codes identiques: 
prendre en compte le premier code génèré.
Si la télécommande génére un seul code différent après chaque appui, c'est ce code 
qui sera noté

La vitesse de déplacement est limitée par la durée des trames IR.  10 s environ pour 90° 

Le bouton "Enter" ou "OK" replace la camera dans une position prédéterminée (ici x 90° / y 90°)

F5MNA  Mars 2013  ( Mon site http://f5mna.free.fr )
*/

#include <IRremote.h>
#include <Servo.h>;  //inclu Servo.h 

Servo Pan;           //Déclaration des servos Pan et Tilt
Servo Tilt;

int RECV_PIN = 11;   //Pin 11 reception données IR
IRrecv irrecv(RECV_PIN);
decode_results results;

char TOP;
int Led = 13;     //LED
int valT, valP;   //Valeurs envoyée aux servomoteurs
int Pos;          // Positions haut, bas, droite, gauche, stop
 
void setup()
{
  Pan.attach(9);     //assigne pin 9 et 10 pour le signal de sortie destiné à commander les servos
  Tilt.attach(10);
 
  Serial.begin(9600);
  irrecv.enableIRIn(); // Démarrage du récepteur
  pinMode(Led, OUTPUT);
  Pos = 0;
  valT = 90;
  valP = 90;
  Serial.println (" Camera Pan/Tilt F5MNA");
  Serial.println ("Reception des valeurs X Y");
  Serial.println (" ");
}

void loop() {
  if (irrecv.decode(&results)) {  // Si un signal est reçu...
    irrecv.resume(); // En attente de la prochaine valeur
    TOP = (results.value);
    
  switch (TOP)
     {
  //Haut
  case 16605343: 
     Pos = 1;
  break; 
  
  // Bas
  case 16607383: 
     Pos = 2;  
  break; 

  //Gauche
  case 16603813:
     Pos = 3; 
  break; 
  
  // Droite
  case 16635943:
    Pos = 4; 
  break; 
 
  //Retour position prédéfinie (90 90). Touche "OK" 
   case 16603303:
     Pos = 0;     
   break; 

  //A allumé  
     case 16584943:   
        digitalWrite(Led, HIGH);
        Serial.println ("Allume");            
  break; 
  
  //E eteint  
     case 16633903:
        digitalWrite(Led, LOW);
        Serial.println ("Eteint");            
  break; 
        }
  //}
 
 switch (Pos)
  {
  case 1: //Haut
     if (valT < 170)  (valT = valT ++) ;
     break; 
  
  case 2: //Bas
     if (valT > 10) (valT = valT --) ;  
     break; 
 
  case 3: //Droite
     if (valP < 170)  (valP = valP ++) ; 
     break; 
  
  case 4: //Gauche 
     if (valP > 10) (valP = valP -- ); 
  break; 
  
  case 0: //Retour position prédéfinie (90 90)

  if (valP != 90) {
  if (valP < 90) {
    valP ++ ;
  }
    if (valP > 90) {
    valP -- ;
  }
  }  
  if (valT != 90)  {
    if (valT < 90) {
    valT ++ ;
  }
    if (valT > 90) {
    valT -- ;
  }
  } 
 } 
  Serial.print ("   X: ");
  Serial.print (valP);
  Serial.print ("   Y: ");
  Serial.println (valT);
 
  Pan.write(valP);                          //Donne au servo Pan la valeur en degrés à atteindre
  Tilt.write(valT); 

}
}
